import com.haulmont.studio.backend.ed.ddl.CustomDdlGenerator
import com.haulmont.studio.common.model.Entity
import com.haulmont.studio.common.model.EntityAttribute
import groovy.transform.CompileStatic

import javax.annotation.Nullable
import java.sql.DatabaseMetaData
import java.sql.SQLException

@CompileStatic
class DdlGeneratorApiStub implements DdlGeneratorDelegate {

    CustomDdlGenerator generator

    @Override
    String getMainDataStoreDatabaseName() {
        return generator.getMainDataStoreDatabaseName()
    }

    @Override
    def getConnection() {
        return generator.getConnection()
    }

    @Override
    String getProjectNamespace() {
        return generator.getProjectNamespace()
    }

    @Override
    String wrapColumnInQuotesIfNeeded(String column) {
        return generator.wrapColumnInQuotesIfNeeded(column)
    }

    @Override
    String getDefaultSchema() {
        return generator.getDefaultSchema()
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


    @Override
    Collection<String> defaultGetColumnIndexNames(DatabaseMetaData metaData, String schema, String tableName, String columnName) {
        return generator.defaultGetColumnIndexNames((DatabaseMetaData) metaData, schema, tableName, columnName)
    }

    @Override
    Collection<String> defaultGetColumnConstraintNames(Object metaData, String schema, String tableName, String columnName) {
        return generator.defaultGetColumnConstraintNames((DatabaseMetaData) metaData, schema, tableName, columnName)
    }

    @Override
    List<String> defaultGetDropColumnConstraintStatements(String tableName, String columnName) {
        return generator.defaultGetDropColumnConstraintStatements(tableName, columnName)
    }

    @Override
    String defaultPrepareColumnForAddScript(String columnName) {
        return generator.defaultPrepareColumnForAddScript(columnName)
    }

    @Override
    String defaultGetColumnType(String attributeType) {
        return generator.defaultGetColumnType(attributeType)
    }

    @Override
    boolean defaultIsScaleDifferent(int attributeScale, int columnScale, String columnType) {
        return generator.defaultIsScaleDifferent(attributeScale, columnScale, columnType)
    }

    @Override
    String defaultGetPrimaryKeyStatement(Object entity) {
        return generator.defaultGetPrimaryKeyStatement((Entity) entity)
    }

    @Override
    String defaultGetPrimaryKeyConstraintStatement(Object entity, boolean includeNotNullClause) {
        return generator.defaultGetPrimaryKeyConstraintStatement((Entity) entity, includeNotNullClause)
    }

    @Override
    boolean defaultIsTypeDifferent(Object attribute, String currentType, String oldType, int oldLength) {
        return generator.defaultIsTypeDifferent((EntityAttribute) attribute, currentType, oldType, oldLength)
    }

    @Override
    String defaultGetPrimaryOrForeignKeyParams(Object attribute) {
        return generator.defaultGetPrimaryOrForeignKeyParams((EntityAttribute) attribute)
    }

    @Override
    String defaultGetTemporalType(String columnType) {
        return generator.defaultGetTemporalType(columnType)
    }

    @Override
    String defaultGetPrimaryOrForeignKeyType(Object attribute) {
        return generator.defaultGetPrimaryOrForeignKeyType((EntityAttribute) attribute)
    }

    @Override
    String defaultReplaceDelimiter(String script) {
        return generator.defaultReplaceDelimiter(script)
    }

    @Override
    Collection<String> defaultGetDropTableConstraintNames(DatabaseMetaData metaDatam, String schema, String tableName) throws SQLException {
        return generator.defaultGetDropTableConstraintNames(metaDatam, schema, tableName)
    }

    @Override
    Integer getIdentifierMaxLength() {
        return -1
    }

    @Override
    void showNotification(String caption, @Nullable String description) {
        generator.showNotification(caption, description)
    }

    @Override
    String getColumnDefinition(Object entity, Object attribute, String column, boolean includeNotNull) {
        return generator.getColumnDefinition((Entity) entity, (EntityAttribute) attribute, column, includeNotNull)
    }

    @Override
    void processScriptAddingMandatoryColumn(StringBuilder script, Object entity, Object attribute, String columnName) {
        generator.processScriptAddingMandatoryColumn(script, (Entity) entity, (EntityAttribute) attribute, columnName)
    }

    @Override
    String getAddColumnsForEmbeddedAttrStatements(Object tableEntity, Object attribute, Collection added) {
        return generator.getAddColumnsForEmbeddedAttrStatements((Entity) tableEntity, (EntityAttribute) attribute, added)
    }

    @Override
    Integer getColumnLength(Object entity, Object attribute) {
        return generator.getColumnLength((Entity) entity, (EntityAttribute) attribute)
    }

    @Override
    String getColumnName(Object attribute, String columnName) {
        return generator.getColumnName((EntityAttribute) attribute, columnName)
    }

    @Override
    String getDecimalParams(Object entity, Object attribute) {
        return generator.getDecimalParams((Entity) entity, (EntityAttribute) attribute)
    }

    @Override
    String getPrimaryKeyColumn(Object entity) {
        return generator.getPrimaryKeyColumn((Entity) entity)
    }

    @Override
    String getIdType(Object entity) {
        return generator.getIdType((Entity) entity)
    }

    @Override
    Object getIdAttribute(Object entity) {
        return generator.getIdAttribute((Entity) entity)
    }

    @Override
    String getDefaultEnumColumnLength() {
        return generator.getDefaultEnumColumnLength()
    }

    @Override
    void processBigDecimalParams(Object attribute, StringBuilder params) {
        generator.processBigDecimalParams((EntityAttribute) attribute, params)
    }
}
